#!/bin/bash

cat > /etc/udev/rules.d/10-sf-usblockdown.rules << EOF
#!/bin/bash

# executes the below bash script from UDEV rules for when USB devices connect, which detect and add a mouse and keyboard in allowed list.
ACTION=="add", SUBSYSTEMS=="usb", RUN+="/bin/sh -c '/etc/udev/01-keyboard-mouse.gen'"
EOF

# This is the script that detects and adds a mouse and keyboard to the allowed list using the UDEV rules.
cat > /etc/udev/01-keyboard-mouse.gen << EOF
#!/bin/bash
# This is the script that detects and adds a mouse and keyboard to the allowed list using the UDEV rules.
devices_ids=\`lsusb | awk '{print \$6}' | awk -F: '{print \$1":"\$2}'\`
echo "" > /etc/udev/rules.d/11-allow-keyboard-mouse.rules
while read device_id
do
    lsusb -v -d "\$device_id" | egrep -i 'keyboard|mouse'
	if [ \$? -eq 0 ]; then
	  # Create a new udev rule file
	  for mouse_id in \$device_id; do
	    echo "ACTION==\"add\", ATTRS{idVendor}==\"\$(echo \$device_id | cut -d: -f1)\", ATTRS{idProduct}==\"\$(echo \$device_id | cut -d: -f2)\" RUN+=\"/bin/sh -c 'echo 1 > /sys\$DEVPATH/authorized'\"" >> /etc/udev/rules.d/11-allow-keyboard-mouse.rules
	  done
	fi
done <<< "\$devices_ids"
sudo udevadm control --reload-rules
EOF

sudo chmod +x /etc/udev/01-keyboard-mouse.gen